<?php

namespace dgsoft\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AdvResTicketingType StructType
 * @package Dg
 * @subpackage Structs
 */
class DgAdvResTicketingType extends AbstractStructBase
{
    /**
     * The AdvReservation
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgAdvReservation
     */
    public $AdvReservation;
    /**
     * The AdvTicketing
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgAdvTicketing
     */
    public $AdvTicketing;
    /**
     * The AdvResInd
     * @var bool
     */
    public $AdvResInd;
    /**
     * The AdvTicketingInd
     * @var bool
     */
    public $AdvTicketingInd;
    /**
     * The RequestedTicketingDate
     * @var string
     */
    public $RequestedTicketingDate;
    /**
     * Constructor method for AdvResTicketingType
     * @uses DgAdvResTicketingType::setAdvReservation()
     * @uses DgAdvResTicketingType::setAdvTicketing()
     * @uses DgAdvResTicketingType::setAdvResInd()
     * @uses DgAdvResTicketingType::setAdvTicketingInd()
     * @uses DgAdvResTicketingType::setRequestedTicketingDate()
     * @param \dgsoft\StructType\DgAdvReservation $advReservation
     * @param \dgsoft\StructType\DgAdvTicketing $advTicketing
     * @param bool $advResInd
     * @param bool $advTicketingInd
     * @param string $requestedTicketingDate
     */
    public function __construct(\dgsoft\StructType\DgAdvReservation $advReservation = null, \dgsoft\StructType\DgAdvTicketing $advTicketing = null, $advResInd = null, $advTicketingInd = null, $requestedTicketingDate = null)
    {
        $this
            ->setAdvReservation($advReservation)
            ->setAdvTicketing($advTicketing)
            ->setAdvResInd($advResInd)
            ->setAdvTicketingInd($advTicketingInd)
            ->setRequestedTicketingDate($requestedTicketingDate);
    }
    /**
     * Get AdvReservation value
     * @return \dgsoft\StructType\DgAdvReservation|null
     */
    public function getAdvReservation()
    {
        return $this->AdvReservation;
    }
    /**
     * Set AdvReservation value
     * @param \dgsoft\StructType\DgAdvReservation $advReservation
     * @return \dgsoft\StructType\DgAdvResTicketingType
     */
    public function setAdvReservation(\dgsoft\StructType\DgAdvReservation $advReservation = null)
    {
        $this->AdvReservation = $advReservation;
        return $this;
    }
    /**
     * Get AdvTicketing value
     * @return \dgsoft\StructType\DgAdvTicketing|null
     */
    public function getAdvTicketing()
    {
        return $this->AdvTicketing;
    }
    /**
     * Set AdvTicketing value
     * @param \dgsoft\StructType\DgAdvTicketing $advTicketing
     * @return \dgsoft\StructType\DgAdvResTicketingType
     */
    public function setAdvTicketing(\dgsoft\StructType\DgAdvTicketing $advTicketing = null)
    {
        $this->AdvTicketing = $advTicketing;
        return $this;
    }
    /**
     * Get AdvResInd value
     * @return bool|null
     */
    public function getAdvResInd()
    {
        return $this->AdvResInd;
    }
    /**
     * Set AdvResInd value
     * @param bool $advResInd
     * @return \dgsoft\StructType\DgAdvResTicketingType
     */
    public function setAdvResInd($advResInd = null)
    {
        // validation for constraint: boolean
        if (!is_null($advResInd) && !is_bool($advResInd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($advResInd)), __LINE__);
        }
        $this->AdvResInd = $advResInd;
        return $this;
    }
    /**
     * Get AdvTicketingInd value
     * @return bool|null
     */
    public function getAdvTicketingInd()
    {
        return $this->AdvTicketingInd;
    }
    /**
     * Set AdvTicketingInd value
     * @param bool $advTicketingInd
     * @return \dgsoft\StructType\DgAdvResTicketingType
     */
    public function setAdvTicketingInd($advTicketingInd = null)
    {
        // validation for constraint: boolean
        if (!is_null($advTicketingInd) && !is_bool($advTicketingInd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($advTicketingInd)), __LINE__);
        }
        $this->AdvTicketingInd = $advTicketingInd;
        return $this;
    }
    /**
     * Get RequestedTicketingDate value
     * @return string|null
     */
    public function getRequestedTicketingDate()
    {
        return $this->RequestedTicketingDate;
    }
    /**
     * Set RequestedTicketingDate value
     * @param string $requestedTicketingDate
     * @return \dgsoft\StructType\DgAdvResTicketingType
     */
    public function setRequestedTicketingDate($requestedTicketingDate = null)
    {
        // validation for constraint: string
        if (!is_null($requestedTicketingDate) && !is_string($requestedTicketingDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($requestedTicketingDate)), __LINE__);
        }
        $this->RequestedTicketingDate = $requestedTicketingDate;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\StructType\DgAdvResTicketingType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
